<?php

namespace App\Http\Controllers;

use App\Models\Desa;
use App\Models\IndukOpd;
use App\Models\UnitKerja;
use Illuminate\Http\Request;
use App\Models\IbuHamilDanBersalin;
use Illuminate\Support\Facades\Auth;

class IbuHamilDanBersalinController extends Controller
{
    protected $routeName = 'IbuHamil';
    protected $viewName = 'IbuHamil';
    protected $title = 'IbuHamil';

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        // return NPA::whereHas('kategori',function($query){
        //     $query->where('kategori','Industri Besar');
        // })->get();
        // dd($request->all());

        $unit_kerja = UnitKerja::all();
        $total = 0;
        $totalk1 = 0;
        $totalk4 = 0;
        $totalk6 = 0;
        $totalfasyankes = 0;
        $totalkf1 = 0;
        $totalkf_lengkap = 0;
        $totalvita = 0;
        $totalibubersalin = 0;
        $indukOpd = IndukOpd::pluck('nama', 'id');
        // $desa = Desa::first();
        // dd($desa->filterDesa(null));
        if(Auth::user()->roles->first()->name !== "Admin"){
            $indukOpd = IndukOpd::where('id', Auth::user()->induk_opd_id)->pluck('nama', 'id');
            foreach(Auth::user()->unit_kerja->desa as $desa){
                if($desa->filterDesa($request->query('year'))){
                    $total += $desa->filterDesa($request->query('year'))->jumlah_ibu_hamil;
                $totalk1 += $desa->filterDesa($request->query('year'))->k1;
                $totalk4 += $desa->filterDesa($request->query('year'))->k4;
                $totalk6 += $desa->filterDesa($request->query('year'))->k6;
                $totalfasyankes += $desa->filterDesa($request->query('year'))->fasyankes;
                $totalkf1 += $desa->filterDesa($request->query('year'))->kf1;
                $totalkf_lengkap += $desa->filterDesa($request->query('year'))->kf_lengkap;
                $totalvita += $desa->filterDesa($request->query('year'))->vita;
                $totalibubersalin += $desa->filterDesa($request->query('year'))->jumlah_ibu_bersalin;
                }
            }
        } else{
            foreach($unit_kerja as $desa){
                $total += $desa->jumlah_ibu_hamil($request->query('year'));
                $totalk1 += $desa->k1($request->query('year'));
                $totalk4 += $desa->k4($request->query('year'));
                $totalk6 += $desa->k6($request->query('year'));
                $totalfasyankes += $desa->fasyankes($request->query('year'));
                $totalkf1 += $desa->kf1($request->query('year'));
                $totalkf_lengkap += $desa->kf_lengkap($request->query('year'));
                $totalvita += $desa->vita($request->query('year'));
                $totalibubersalin += $desa->jumlah_ibu_bersalin($request->query('year'));
            }
        }

        // dd(UnitKerja::first()->jumlah_k1);

        $data=[
            'route'=>$this->routeName,
            'title'=>$this->title,
            'induk_opd_arr' => $indukOpd,
            'unit_kerja' =>  $unit_kerja,
            'desa' => Auth::user()->unit_kerja?Auth::user()->unit_kerja->desa:Desa::all(),
            'total_ibu_hamil' => $total,
            'total_k1' => $totalk1,
            'total_k4' => $totalk4,
            'total_k6' => $totalk6,
            'total_fasyankes' => $totalfasyankes,
            'total_kf1' => $totalkf1,
            'total_kf_lengkap' => $totalkf_lengkap,
            'total_vita' => $totalvita,
            'total_ibu_bersalin' => $totalibubersalin,
            // 'jabatan' => Jabatan::get(),
            // 'jenis_jabatan' => JenisJabatan::pluck('nama', 'id'),
            // 'unit_organisasi' => UnitOrganisasi::get()
        ];

        return view($this->viewName.'.index')->with($data);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        try {
            $IbuHamil = IbuHamilDanBersalin::where('id', $request->id)->first();
           
            $jumlah_ibu_hamil = $IbuHamil->jumlah_ibu_hamil;
            $jumlah_ibu_bersalin = $IbuHamil->jumlah_ibu_bersalin;
            $IbuHamil->update([
                $request->name => $request->value,
            ]);
            $desa = $IbuHamil->Desa->UnitKerja;
            $total = 0;
            $total_ibu_hamil = 0;
            $total_ibu_bersalin = 0;
            $percentage = 0;

            foreach ($desa->desa as $key => $value) {
                # code...
                // dd($value->filterDesa($request->year), $request->year);
                $total_ibu_hamil += $value->filterDesa($request->year)->jumlah_ibu_hamil;
                $total_ibu_bersalin += $value->filterDesa($request->year)->jumlah_ibu_bersalin;
                $total += $value->filterDesa($request->year)->{$request->name};
            }
            if($request->name == "k1" || $request->name == "k4"  || $request->name == "k6"){
                $percentage = $total_ibu_hamil > 0?number_format($total/$total_ibu_hamil * 100, 2):0;
            } else {
               $percentage =  $total_ibu_bersalin > 0?number_format($total/$total_ibu_bersalin * 100, 2):0;
            }
            // dd(($IbuHamil->fasyankes/$jumlah_ibu_bersalin) * 100, $IbuHamil->fasyankes, $jumlah_ibu_bersalin, gettype($IbuHamil->fasyankes));
            return response()->json([
                'status' => 'success',
                'k1' => $jumlah_ibu_hamil > 0?number_format($IbuHamil->k1/$jumlah_ibu_hamil * 100, 2):0,
                'k4' => $jumlah_ibu_hamil > 0?number_format($IbuHamil->k4/$jumlah_ibu_hamil * 100, 2):0,
                'k6' => $jumlah_ibu_hamil > 0?number_format($IbuHamil->k6/$jumlah_ibu_hamil * 100, 2):0,
                'fasyankes' => $jumlah_ibu_bersalin > 0?number_format(((int)$IbuHamil->fasyankes/$jumlah_ibu_bersalin) * 100, 2):0,
                'kf1' => $jumlah_ibu_bersalin > 0?number_format(((int)$IbuHamil->kf1/$jumlah_ibu_bersalin) * 100, 2):0,
                'kf_lengkap' => $jumlah_ibu_bersalin > 0?number_format(((int)$IbuHamil->kf_lengkap/$jumlah_ibu_bersalin) * 100, 2):0,
                'vita' => $jumlah_ibu_bersalin > 0?number_format(((int)$IbuHamil->vita/$jumlah_ibu_bersalin) * 100, 2):0,
                'column' => $request->name,
                'total' => $total,
                'percentage' => $percentage,
            ]);
        } catch (\Throwable $th) {
            //throw $th;
            return response()->json([
                'status' => 'fail',
                'message' => $th->getMessage(),
            ]);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
        $IbuHamil = IbuHamilDanBersalin::where('desa_id', $id)->first();
        try {
            $IbuHamil->update($request->all());
            return redirect(route($this->routeName.'.index'))->with(['success'=>'Berhasil Mengubah Data']);
        } catch (\Throwable $th) {
            //throw $th;
            dd($th->getMessage());
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
    public function report(Request $request)
    {
        //
        // dd("A");
        $unit_kerja = UnitKerja::all();
        $total = 0;
        $totalk1 = 0;
        $totalk4 = 0;
        $totalk6 = 0;
        $totalfasyankes = 0;
        $totalkf1 = 0;
        $totalkf_lengkap = 0;
        $totalvita = 0;
        $totalibubersalin = 0;
        $indukOpd = IndukOpd::pluck('nama', 'id');
        // $desa = Desa::first();
        // dd($desa->filterDesa(null));
        if(Auth::user()->roles->first()->name !== "Admin"){
            $indukOpd = IndukOpd::where('id', Auth::user()->induk_opd_id)->pluck('nama', 'id');
            foreach(Auth::user()->unit_kerja->desa as $desa){
                if($desa->filterDesa($request->query('year'))){
                    $total += $desa->filterDesa($request->query('year'))->jumlah_ibu_hamil;
                $totalk1 += $desa->filterDesa($request->query('year'))->k1;
                $totalk4 += $desa->filterDesa($request->query('year'))->k4;
                $totalk6 += $desa->filterDesa($request->query('year'))->k6;
                $totalfasyankes += $desa->filterDesa($request->query('year'))->fasyankes;
                $totalkf1 += $desa->filterDesa($request->query('year'))->kf1;
                $totalkf_lengkap += $desa->filterDesa($request->query('year'))->kf_lengkap;
                $totalvita += $desa->filterDesa($request->query('year'))->vita;
                $totalibubersalin += $desa->filterDesa($request->query('year'))->jumlah_ibu_bersalin;
                }
            }
        } else{
            foreach($unit_kerja as $desa){
                $total += $desa->jumlah_ibu_hamil($request->query('year'));
                $totalk1 += $desa->k1($request->query('year'));
                $totalk4 += $desa->k4($request->query('year'));
                $totalk6 += $desa->k6($request->query('year'));
                $totalfasyankes += $desa->fasyankes($request->query('year'));
                $totalkf1 += $desa->kf1($request->query('year'));
                $totalkf_lengkap += $desa->kf_lengkap($request->query('year'));
                $totalvita += $desa->vita($request->query('year'));
                $totalibubersalin += $desa->jumlah_ibu_bersalin($request->query('year'));
            }
        }

        // dd(UnitKerja::first()->jumlah_k1);

        $data=[
            'route'=>$this->routeName,
            'title'=>$this->title,
            'induk_opd_arr' => $indukOpd,
            'unit_kerja' =>  $unit_kerja,
            'desa' => Auth::user()->unit_kerja?Auth::user()->unit_kerja->desa:Desa::all(),
            'total_ibu_hamil' => $total,
            'total_k1' => $totalk1,
            'total_k4' => $totalk4,
            'total_k6' => $totalk6,
            'total_fasyankes' => $totalfasyankes,
            'total_kf1' => $totalkf1,
            'total_kf_lengkap' => $totalkf_lengkap,
            'total_vita' => $totalvita,
            'total_ibu_bersalin' => $totalibubersalin,
            // 'jabatan' => Jabatan::get(),
            // 'jenis_jabatan' => JenisJabatan::pluck('nama', 'id'),
            // 'unit_organisasi' => UnitOrganisasi::get()
        ];

        return view($this->viewName.'.report')->with($data);
    }
    public function apiEdit($id){

        $unitKerja = UnitKerja::where('id', $id)->first();
        $IbuHamil = IbuHamilDanBersalin::where('desa_id', $id)->first();

        return response()->json([
            'status' => 'success',
            'data' => $unitKerja,
            'IbuHamil' => $IbuHamil,
        ]);
    }
    public function apiLock(Request $request){

        $unitKerja = UnitKerja::where('id', $request->id)->first();    
        $unitKerja->lock($request->year, $request->status);   

        return response()->json([
            'status' => 'success',
            'data' => $unitKerja,
        ]);
    }
}
